﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;

namespace ComparerTest
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void 打开图像1ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            LoadImage(1);
        }

        private void 打开图像2ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            LoadImage(2);
        }

        private void LoadImage(object mdiId)
        {
            using (OpenFileDialog dialog = new OpenFileDialog())
            {
                dialog.Filter = "所有图片文件(*.bmp;*.png;*.jpg;*.jpeg)|*.bmp;*.png;*.jpg;*.jpeg";
                dialog.CheckFileExists = true;
                dialog.ShowReadOnly = false;
                if (dialog.ShowDialog() == DialogResult.OK)
                {
                    Bitmap bmp = (Bitmap)Bitmap.FromFile(dialog.FileName);
                    SetMdiForm(mdiId, bmp, "图片文件" + mdiId.ToString() + ":" + dialog.FileName);
                }
            }
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="mdiId"></param>
        /// <param name="bmp"></param>
        private void SetMdiForm(object mdiId, Bitmap bmp, string title)
        {
            Form form = null;
            if (this.MdiChildren != null)
            {
                foreach (Form f in this.MdiChildren)
                {
                    if (object.Equals(f.Tag, mdiId))
                    {
                        form = f;
                        break;
                    }
                }
            }
            if (form == null)
            {
                form = new Form();
                form.MdiParent = this;
                form.Size = this.Size;
                form.Tag = mdiId;
                form.AutoScroll = true;

                PictureBox pb = new PictureBox();
                pb.Size = bmp.Size;
                pb.Location = new Point(0, 0);
                form.Controls.Add(pb);
            }
            ((PictureBox)form.Controls[0]).Image = bmp;
            form.Text = title;
            form.Show();
        }

        private void 比较图像ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.MdiChildren != null && this.MdiChildren.Length == 2)
            {
                Bitmap bmp1 = (Bitmap)((PictureBox)this.MdiChildren[0].Controls[0]).Image;
                Bitmap bmp2 = (Bitmap)((PictureBox)this.MdiChildren[1].Controls[0]).Image;

                Stopwatch watch = new Stopwatch();
                watch.Start();
                List<Rectangle> rects = Core.ImageComparer.Compare(bmp1, bmp2);
                watch.Stop();

                if (rects.Count != 0)
                {
                    using (Graphics g = Graphics.FromImage(bmp1))
                    {
                        g.DrawRectangles(new Pen(Brushes.Blue, 1f), rects.ToArray());
                        g.Save();
                        this.MdiChildren[0].Refresh();
                    }
                    using (Graphics g = Graphics.FromImage(bmp2))
                    {
                        g.DrawRectangles(new Pen(Brushes.Red, 1f), rects.ToArray());
                        g.Save();
                        this.MdiChildren[1].Refresh();
                    }
                }
                this.MdiChildren[1].Text = "比较完成,共有 " + rects.Count.ToString() + " 处不同,花费:" + watch.ElapsedMilliseconds + " ms";
            }
        }
    }
}
